/**
 * @(#)MaileonException.java
 */
package com.maileon.api;

import javax.ws.rs.core.Response.StatusType;

// TODO: Auto-generated Javadoc
/**
 * The Class MaileonException.
 *
 */
public class MaileonException extends RuntimeException {

	/** The status code. */
	private int statusCode;

	/** The reason phrase. */
	private String reasonPhrase;

	/**
	 * Instantiates a new maileon exception.
	 */
	public MaileonException() {

	}

	/**
	 * Instantiates a new maileon exception.
	 *
	 * @param message the message
	 */
	public MaileonException(String message) {
		super(message);
	}

	/**
	 * Instantiates a new maileon exception.
	 *
	 * @param message the message
	 * @param t the t
	 */
	public MaileonException(String message, Throwable t) {
		super(message, t);
	}

	/**
	 * Instantiates a new maileon exception.
	 *
	 * @param statusCode the status code
	 * @param reasonPhrase the reason phrase
	 */
	public MaileonException(int statusCode, String reasonPhrase) {
		this.statusCode = statusCode;
		this.reasonPhrase = reasonPhrase;
	}

	/**
	 * Instantiates a new maileon exception.
	 *
	 * @param status the status
	 */
	public MaileonException(StatusType status) {
		statusCode = status.getStatusCode();
		reasonPhrase = status.getReasonPhrase();
	}

	/**
	 * Instantiates a new maileon exception.
	 *
	 * @param status the status
	 * @param message the message
	 */
	public MaileonException(StatusType status, String message) {
		super(message);
		statusCode = status.getStatusCode();
		reasonPhrase = status.getReasonPhrase();
	}

	/**
	 * Gets the status code.
	 *
	 * @return the status code
	 */
	public int getStatusCode() {
		return statusCode;
	}

	/**
	 * Gets the reason phrase.
	 *
	 * @return the reason phrase
	 */
	public String getReasonPhrase() {
		return reasonPhrase;
	}
}
