/**
 * @(#)QueryPrettyPrinter.java
 */
package com.maileon.api;

import com.maileon.api.AbstractMaileonService.QueryParameters;
import java.net.URLEncoder;

import javax.ws.rs.core.MediaType;


// TODO: Auto-generated Javadoc
/**
 * The Class QueryPrettyPrinter.
 *
 */
class QueryPrettyPrinter {

    /**
     * Prints the.
     *
     * @param method the method
     * @param baseUri the base uri
     * @param path the path
     * @param parameters the parameters
     * @param accept the accept
     * @param type the type
     * @return the string
     */
    public static String print(String method, String baseUri, String path, QueryParameters parameters, MediaType accept, MediaType type) {
        StringBuilder sb = new StringBuilder("\r\n");
		sb.append(method).append(" ").append(baseUri).append("/").append(path);
        if (parameters != null && parameters.size() > 0) {
            sb.append("?");
            for (int i = 0; i < parameters.size(); i++) {
                try {
                    if (i != 0) {
                        sb.append("&");
                    }
                    sb.append(URLEncoder.encode(parameters.getName(i), "UTF-8")).append("=").append(URLEncoder.encode(parameters.getValue(i), "UTF-8"));
                } catch (Throwable e) {

                }
            }
        }
        if (accept != null) {
            sb.append("\r\n").append("Accept: ").append(accept);
        }
        if (type != null) {
            sb.append("\r\n").append("Content-Type: ").append(type);
        }

        return sb.toString();
    }
}
