/**
 * @(#)ResponsePrettyPrinter.java
 */
package com.maileon.api;

import java.io.StringWriter;
import java.util.Arrays;
import java.util.List;

import javax.ws.rs.core.MultivaluedMap;

import org.dom4j.DocumentHelper;
import org.dom4j.io.OutputFormat;
import org.dom4j.io.XMLWriter;

// TODO: Auto-generated Javadoc
/**
 * The Class ResponsePrettyPrinter.
 *
 */
class ResponsePrettyPrinter {

    /**
     * The Constant blacklist.
     */
    private static final List<String> BLACKLIST
            = Arrays.asList("Date", "Transfer-Encoding", "Via", "Keep-Alive", "Connection", "Server", "X-Powered-By");

    /**
     * Prints the.
     *
     * @param resp the resp
     * @return the string
     */
    public static String print(ResponseWrapper resp) {
        StringBuilder sb = new StringBuilder("\r\n");
        // print status line
        sb.append("Status: ").append(resp.getStatusCode()).append(" ").append(resp.getReasonPhrase()).append("\r\n");
        // print headers
        MultivaluedMap<String, String> headers = resp.getHeaders();
        for (String key : headers.keySet()) {
            if (!BLACKLIST.contains(key)) {
                List<String> values = headers.get(key);
                for (String value : values) {
                    sb.append(key).append(": ").append(value).append("\r\n");
                }
            }
        }
        // print content
        if (resp.getType() != null && resp.getType().isCompatible(AbstractMaileonService.MAILEON_XML_TYPE)) {
            try {
                String xml = resp.getEntityAsString();
                StringWriter sw = new StringWriter();
                XMLWriter writer = new XMLWriter(sw, OutputFormat.createPrettyPrint());
                writer.write(DocumentHelper.parseText(xml));
                sb.append(sw.toString());
            } catch (Throwable e) {

            }
        }
        return sb.toString();
    }
}
