/**
 * @(#)FieldBackupInstructionAdaptor.java
 */
package com.maileon.api.contacts;

import java.util.ArrayList;
import java.util.List;

import org.dom4j.DocumentHelper;
import org.dom4j.Element;

import com.maileon.api.XmlUtils;

public class FieldBackupInstructionAdaptor {

	public static List<FieldBackupInstruction> fromXml(List<Element> l) {
		List<FieldBackupInstruction> fbi = new ArrayList<>();
		for (Element e : l) {
			fbi.add(fromXml(e));
		}
		return fbi;
	}
	
	public static FieldBackupInstruction fromXml(Element e) {
		FieldBackupInstruction fbi = new FieldBackupInstruction();
		if (null != e.element("id"))
		fbi.setId(XmlUtils.getNullableLongValue(e.element("id")));
		if (null != e.element("name"))
		fbi.setName(XmlUtils.getNullableStringValue(e.element("name")));
		if (null != e.element("option"))
		fbi.setOption(XmlUtils.getNullableStringValue(e.element("option")));
		if (null != e.element("subtype"))
		fbi.setSubtype(XmlUtils.getNullableStringValue(e.element("subtype")));
		if (null != e.element("type"))
		fbi.setType(XmlUtils.getNullableStringValue(e.element("type")));
		if (null != e.element("anonymizable"))
			fbi.setAnonymizable(XmlUtils.getNullableBooleanValue(e.element("anonymizable")));
		return fbi;
	}
	
	public static Element toXml(FieldBackupInstruction fbi) {
		Element root = DocumentHelper.createElement("backup_instruction");
		appendChild(root, "id", fbi.getId());
		appendChild(root, "anonymizable", fbi.getAnonymizable());
		appendChild(root, "type", fbi.getType());
		appendChild(root, "subtype", fbi.getSubtype());
		appendChild(root, "name", fbi.getName());
		appendChild(root, "option", fbi.getOption());
		return root;
	}
	
	private static void appendChild(Element parent, String childName, Object value) {
		if (value == null) {
			return;
		}
		Element child = DocumentHelper.createElement(childName);
		parent.add(child);
		child.setText(value.toString());
	}
}
