/*
 * @(#)CheckedLink.java
 */
package com.maileon.api.mailings.checks;

import java.io.Serializable;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlType;
import org.json.simple.JSONArray;
import org.json.simple.JSONObject;

/**
 * Result information for Link Check.
 */
@XmlType(propOrder={"trackable", "format", "url", "tags", "layout", "status", "errors", "warnings"})
public class CheckedLink implements Serializable {

    private boolean trackable;

    private String format;

    private String url;

    private List<String> tags;

    private String layout;

    private String status; // success, warning, error

    private List<String> errors;

    private List<String> warnings;

    @XmlElement
    public boolean isTrackable() {
        return trackable;
    }

    public void setTrackable(boolean trackable) {
        this.trackable = trackable;
    }

    @XmlElement
    public String getFormat() {
        return format;
    }

    public void setFormat(String format) {
        this.format = format;
    }

    @XmlElement
    public String getUrl() {
        return url;
    }

    public void setUrl(String url) {
        this.url = url;
    }

    @XmlElement
    public List<String> getTags() {
        return tags;
    }

    public void setTags(List<String> tags) {
        this.tags = tags;
    }

    @XmlElement
    public String getLayout() {
        return layout;
    }

    public void setLayout(String layout) {
        this.layout = layout;
    }

    @XmlElement
    public String getStatus() {
        return status;
    }

    public void setStatus(String status) {
        this.status = status;
    }

    @XmlElement
    public List<String> getErrors() {
        return errors;
    }

    public void setErrors(List<String> errors) {
        this.errors = errors;
    }

    @XmlElement
    public List<String> getWarnings() {
        return warnings;
    }

    public void setWarnings(List<String> warnings) {
        this.warnings = warnings;
    }

    @Override
    public String toString() {
        Map<String, Object> map = new HashMap<>();
        map.put("trackable", trackable);
        map.put("format", format);
        map.put("url", url);
        map.put("layout", layout);
        map.put("status", status);
        map.put("tags", JSONArray.toJSONString(tags));
        map.put("errors", JSONArray.toJSONString(errors));
        map.put("warnings", JSONArray.toJSONString(warnings));
        return JSONObject.toJSONString(map);
    }

}
