/*
 * @(#)PersonalizationCheckResult.java
 */
package com.maileon.api.mailings.checks;

import com.maileon.api.mailings.Personalization;
import java.io.Serializable;
import java.util.Date;
import java.util.List;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;

/**
 * Result for Personalization Check
 */
@XmlRootElement(name="PersonalizationCheck")
@XmlType(propOrder={"mailingId", "timestamp", "state", "targetGroupSize", "misses", "subjectPersonalizations",
    "fromAliasPersonalizations", "recipientAliasPersonalizations", "htmlPersonalizations", "textPersonalizations"})
public class PersonalizationCheckResult implements Serializable {

    private long mailingId;

    private Date timestamp;

    private String state;

    private int targetGroupSize;

    private int misses;

    private List<PersonalizationInformation> subjectPersonalizations;

    private List<PersonalizationInformation> fromAliasPersonalizations;

    private List<PersonalizationInformation> recipientAliasPersonalizations;

    private List<PersonalizationInformation> htmlPersonalizations;

    private List<PersonalizationInformation> textPersonalizations;

    @Override
    public String toString() {
        String s = "mailingId: " + mailingId
                + ", timestamp: " + timestamp
                + ", state: " + state
                + ", targetGroupSize: " + targetGroupSize
                + ", misses: " + misses;
        return s;
    }

    @XmlElement
    public int getTargetGroupSize() {
        return targetGroupSize;
    }

    public void setTargetGroupSize(int targetGroupSize) {
        this.targetGroupSize = targetGroupSize;
    }

    @XmlElement
    public int getMisses() {
        return misses;
    }

    public void setMisses(int misses) {
        this.misses = misses;
    }

    @XmlElementWrapper(name="subjectPersonalizations")
    @XmlElement(name = "item", type=Personalization.class)
    public List<PersonalizationInformation> getSubjectPersonalizations() {
        return subjectPersonalizations;
    }

    public void setSubjectPersonalizations(List<PersonalizationInformation> subjectPersonalizations) {
        this.subjectPersonalizations = subjectPersonalizations;
    }

    @XmlElementWrapper(name="fromAliasPersonalizations")
    @XmlElement(name = "item", type=Personalization.class)
    public List<PersonalizationInformation> getFromAliasPersonalizations() {
        return fromAliasPersonalizations;
    }

    public void setFromAliasPersonalizations(List<PersonalizationInformation> fromAliasPersonalizations) {
        this.fromAliasPersonalizations = fromAliasPersonalizations;
    }

    @XmlElementWrapper(name="recipientAliasPersonalizations")
    @XmlElement(name = "item", type=Personalization.class)
    public List<PersonalizationInformation> getRecipientAliasPersonalizations() {
        return recipientAliasPersonalizations;
    }

    public void setRecipientAliasPersonalizations(List<PersonalizationInformation> recipientAliasPersonalizations) {
        this.recipientAliasPersonalizations = recipientAliasPersonalizations;
    }

    @XmlElementWrapper(name="htmlPersonalizations")
    @XmlElement(name = "item", type=Personalization.class)
    public List<PersonalizationInformation> getHtmlPersonalizations() {
        return htmlPersonalizations;
    }

    public void setHtmlPersonalizations(List<PersonalizationInformation> htmlPersonalizations) {
        this.htmlPersonalizations = htmlPersonalizations;
    }

    @XmlElementWrapper(name="textPersonalizations")
    @XmlElement(name = "item", type=Personalization.class)
    public List<PersonalizationInformation> getTextPersonalizations() {
        return textPersonalizations;
    }

    public void setTextPersonalizations(List<PersonalizationInformation> textPersonalizations) {
        this.textPersonalizations = textPersonalizations;
    }

//    @Override
//    public String toString() {
//        Map<String, Object> map = new HashMap<>();
//        map.put("targetGroupSize", targetGroupSize);
//        map.put("misses", misses);
//        List<String> sl = new ArrayList<>();
//        for (PersonalizationInformation p : subjectPersonalizations) {
//            sl.add(print(p));
//        }
//        map.put("subjectPersonalizations", JSONArray.toJSONString(sl));
//        List<String> fal = new ArrayList<>();
//        for (PersonalizationInformation p : fromAliasPersonalizations) {
//            fal.add(print(p));
//        }
//        map.put("fromAliasPersonalizations", JSONArray.toJSONString(fal));
//        List<String> ral = new ArrayList<>();
//        for (PersonalizationInformation p : recipientAliasPersonalizations) {
//            ral.add(print(p));
//        }
//        map.put("recipientAliasPersonalizations", JSONArray.toJSONString(ral));
//        List<String> hl = new ArrayList<>();
//        for (PersonalizationInformation p : htmlPersonalizations) {
//            hl.add(print(p));
//        }
//        map.put("htmlPersonalizations", JSONArray.toJSONString(hl));
//        List<String> tl = new ArrayList<>();
//        for (PersonalizationInformation p : textPersonalizations) {
//            tl.add(print(p));
//        }
//        map.put("textPersonalizations", JSONArray.toJSONString(tl));
//        return JSONObject.toJSONString(map);
//    }
//
//    private String print(PersonalizationInformation p) {
//        Map<String, Object> map = new HashMap<>();
//        map.put("occursInConditionalContent", p.isOccursInConditionalContent());
//        map.put("conditionalContentRuleId", p.getConditionalContentRuleId());
//        map.put("conditionalContentRulesetId", p.getConditionalContentRulesetId());
//        map.put("fallbacks", p.getFallbacks());
//        map.put("fallbackValue", p.getHasFallbackValue());
//        map.put("hits", p.getHits());
//        map.put("misses", p.getMisses());
//        map.put("propertyName", p.getPropertyName());
//        map.put("type", p.getType());
//        return JSONObject.toJSONString(map);
//    }

    @XmlElement
    public long getMailingId() {
        return mailingId;
    }

    public void setMailingId(long mailingId) {
        this.mailingId = mailingId;
    }

    @XmlElement
    public Date getTimestamp() {
        return timestamp;
    }

    public void setTimestamp(Date timestamp) {
        this.timestamp = timestamp;
    }

    @XmlElement
    public String getState() {
        return state;
    }

    public void setState(String state) {
        this.state = state;
    }
}
