package com.maileon.api.blacklists;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertTrue;

import com.maileon.api.MaileonException;
import com.maileon.api.test.TestProperties;
import org.junit.BeforeClass;
import org.junit.Test;

import java.util.Arrays;
import java.util.List;
import java.util.UUID;

// There needs to be at least one blacklist in the account

public class MaileonBlacklistsServiceTest {

    private static TestProperties testProperties;
    private static MaileonBlacklistsService service;

    private static Long idExistingBlacklist = null;
    

    @BeforeClass
    public static void setUp() throws MaileonException {
        testProperties = new TestProperties();
        service = new MaileonBlacklistsService(testProperties.getMaileonConfiguration());
        service.setDebug(testProperties.isDebug());

        List<Blacklist> blacklists = service.getBlacklists();
        idExistingBlacklist = blacklists.get(0).getId();
    }

    @Test
    public void testGetBlacklists() throws MaileonException {
        List<Blacklist> blacklists = service.getBlacklists();
        assertTrue(blacklists.size() > 0);
    }
    
    @Test
    public void testGetBlacklist() throws MaileonException {
        Blacklist blacklist = service.getBlacklist(idExistingBlacklist);
        assertEquals(blacklist.getId(), idExistingBlacklist);
    }
    
    @Test
    public void testAddBlacklistEntries() throws MaileonException {
        service.addBlacklistEntries(idExistingBlacklist, "test_blacklist_import_" + UUID.randomUUID().toString(), Arrays.asList("test.blacklist1@somewhere.com", "*@spamtrap.com"));
    }
}
